          section   TEXT

          xdef      _fi2_call
          xref      __usefi2
          xref      __freefi2
          xref      __c2qdos
          xref      __freestr

PARAMARK1 equ       '<<%F'                        | Additionnal parameter
PARAMARK2 equ       'I2>>'                        |  marker.
MAGIC     equ       $4AFB                         Magic word.

* Prototype: int fi2_call(chanid_t con_id, int key, char * filename);

_fi2_call MOVEM.L   D3/D4/A2-A4,-(SP)             Save the context.
          LEA       24(SP),A3                     Pointer on first parameter.
          MOVEA.L   8(A3),A1                      Filename address (C string).
          JSR       __c2qdos                      Turn C string into a QDOS one.
          BNE.S     FI2CALL1                      If error, return now.
          MOVE.L    A0,D4                         Save filename address.
          MOVEA.L   A0,A2                         Save filename address.
          MOVE.W    (A0)+,D0                      Filename length.
          MOVE.W    D0,D2                         Save it.
          BRA.S     FI2CALL3                      Start search for <<%FI2>>.
FI2CALL4  CMPI.L    #PARAMARK1,(A0)               Parameter marker (part 1) ?
          BNE.S     FI2CALL5                      If no, then jump over...
          CMPI.L    #PARAMARK2,4(A0)              Parameter marker (part 2) ?
          BNE.S     FI2CALL5                      If no, then jump over...
          MOVE.W    #MAGIC,(A0)                   Store the magic word.
          MOVE.L    A0,D1                         | Compute the true length of
          SUB.L     A2,D1                         |  the filename.
          SUBQ.L    #2,D1                         |
          SUB.W     D1,D2                         Substract it from total length
          SUBQ.W    #8,D2                         Substract length of "<<%FI2>>"
          MOVE.W    D2,6(A0)                      Store the parameter length.
          CMPI.B    #' ',-1(A0)                   Is there a padding space ?
          BNE.S     FI2CALL6                      If no, then jump over...
          SUBQ.L    #1,D1                         Do not count this space.
FI2CALL6  MOVE.W    D1,(A2)                       Store filename actual length.
          BRA.S     FI2CALL7                      Parameter processed...
FI2CALL5  ADDQ.L    #2,A0                         | Go two characters forward
          SUBQ.W    #1,D0                         |  and check again until the
FI2CALL3  DBMI      D0,FI2CALL4                   |  end of the string.
FI2CALL7  MOVE.L    #'CALL',D2                    Extension to be used.
          JSR       __usefi2                      Use it.
          MOVEA.L   D4,A0                         Restore filename address.
          BEQ.S     FI2CALL2                      If no error, jump over.
          JSR       __freestr                     Free the filename heap space.
          BRA.S     FI2CALL1                      And return.
FI2CALL2  MOVE.L    (A3)+,D1                      Console channel Id (or -1).
          MOVE.L    (A3),D3                       Key.
          JSR       (A4)                          Call the extension.
          JSR       __freestr                     Free the filename heap space.
          JSR       __freefi2                     Free the extension thing.
FI2CALL1  MOVEM.L   (SP)+,D3/D4/A2-A4             Restore the context.
          RTS                                     Return to calling function.

          end
