          section   TEXT

          xdef      __getext

* This sub-routine gets an extension from a C string (pointed to by A1) and puts
* it into D1.L. The C string is checked for more than 4 characters (extension
* size limit) and a bad parameter error is returned if so.
* Modified registers: D0, D1, A1.

__getext  MOVEQ     #0,D1                         Extension name storage.
          MOVEQ     #3,D0                         Four characters maximum.
GETEXT1   LSL.L     #8,D1                         Make room for a new char.
          MOVE.B    (A1)+,D1                      Store the character.
          DBEQ      D0,GETEXT1                    Repeat until end of str or 4c.
          BNE.S     GETEXT4                       If >= 4 chars, jump.
          LSR.L     #8,D1                         Get rid of the NULL char.
          BRA.S     GETEXT2                       Return without error.
GETEXT4   MOVEQ     #-15,D0                       Bad parameter error code.
          TST.B     (A1)                          Is there another character ?
          BNE.S     GETEXT3                       If yes, return with error.
GETEXT2   MOVEQ     #0,D0                         No error.
GETEXT3   TST.L     D0                            Set CCR accordingly to error.
          RTS                                     Return.

          end
